#include<bits/stdc++.h>
using namespace std;
int n,m,fa[500005][25],dep[500005],depmax[500005][25];
vector<int> son[500005];
bool visit[500005];
int LOG[500005];
void Log()
{
	int aa=1,a=0;
	for(int i=1;i<=n;i++)
	{
		LOG[i]=a;
		if(i==aa)
		{
			aa*=2;
			a++;
		}
	}
}
void dfs(int x)
{
	for(int i=0;i<son[x].size();i++)
	{
		int y=son[x][i];
		if(!visit[y])
		{
			fa[y][0]=x;
			visit[y]=true;
			dep[y]=dep[x]+1;
			dfs(y);
		}
	}
}
struct Q
{
	int l,r,k;
}q[500005];
int LCA(int x,int y)
{
	if(dep[y]>dep[x])
	{
		swap(x,y);
	}
	int cha=dep[x]-dep[y];
	int aa=0;
	while(cha)
	{
		if(cha&1)x=fa[x][aa];
		aa++;
		cha>>=1;
	}
	if(x!=y)
	{
		for(int i=20;i>=0;i--)
		{
			if(fa[x][i]!=fa[y][i])
			{
				x=fa[x][i];
				y=fa[y][i];
			}
		}
		return fa[x][0];
	}
	else return x;
}
int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	cin>>n;
	for(int i=1;i<n;i++)
	{
		int x,y;
		scanf("%d%d",&x,&y);
		son[x].push_back(y);
		son[y].push_back(x);
	}
	dep[1]=1;
	visit[1]=true;
	dfs(1);
	for(int k=1;k<=20;k++)
	{
		for(int i=1;i<=n;i++)
		{
			fa[i][k]=fa[fa[i][k-1]][k-1];
		}
	}
	for(int i=1;i<=n;i++)
	{
		depmax[i][0]=i;
	}
	for(int k=1;k<=20;k++)
	{
		for(int i=1;i<=n;i++)
		{
			if(dep[depmax[i][k-1]]<dep[depmax[i+(1<<(k-1))][k-1]])
			{
				depmax[i][k]=depmax[i][k-1];
			}
			else
			{
				depmax[i][k]=depmax[i+(1<<(k-1))][k-1];
			}
		}
	}
	cin>>m;
	bool flag=true;
	for(int i=1;i<=m;i++)
	{
		scanf("%d%d%d",&q[i].l,&q[i].r,&q[i].k);
		if(q[i].k!=q[i].r-q[i].l+1)
		{
			flag=false;
		}
	}
	if(flag)
	{
		for(int i=1;i<=m;i++)
		{
			int l=q[i].l,r=q[i].r,k=q[i].k;
			int len=r-l+1;
			printf("%d\n",min(dep[depmax[l][LOG[len]]],dep[depmax[r-LOG[len]+1][LOG[len]]]));
		}
	}
	else
	{
		for(int i=1;i<=m;i++)
		{
			int l=q[i].l,r=q[i].r,k=q[i].k;
			int sum=1;
			for(int j=l;j<=r-k+1;j++)
			{
				int A=j;
				for(int w=j+1;w<=j+k-1;w++)
				{
					A=LCA(A,w);
				}
				if(dep[A]>dep[sum])
				{
					sum=A;
				}
			}
			printf("%d\n",dep[sum]);
		}
	}
	
	return 0;
}
